Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members | Related Pages

# Parcour Class Reference

Contains a walking parcour with all relevant data to calculate next useful MotionRequest, resulting fitness, ... More...

`#include <Parcour.h>`

Inheritance diagram for Parcour:

[legend]
Collaboration diagram for Parcour:

[legend]
List of all members.

## Public Member Functions
| Parcour ()
| Constructor.
| ~Parcour ()
| Destructor.
void | start ()
| start walking on the parcour: set start time, reset fitness stuff
void | update (Pose2D robotPose, Vector3< double > accel, bool blind)
| update the state of the parcour with all current data
Pose2D | getMotionRequest ()
| return a MotionRequest that is useful at the moment to follow the parcour
double | getUnifiedSpeed ()
| return something like speed in mm/s considering a useful portion of the integral errors
virtual Pose2D | getTargetPose (unsigned long targetTime)=0
## Public Attributes
unsigned long | updateCount
unsigned long | startTime
unsigned long | lastTime
Pose2D | lastRobotPose
double | minX
double | maxX
double | yDiffIntegral
double | arcDiffIntegral
int | blindCount
double | zAccelIntegral

## Detailed Description

Contains a walking parcour with all relevant data to calculate next useful MotionRequest, resulting fitness, ...

Definition at line 20 of file Parcour.h.

## Constructor & Destructor Documentation

Parcour::Parcour | ( |  | ) | `[inline]`

| Constructor. Definition at line 24 of file Parcour.h. References arcDiffIntegral, blindCount, lastRobotPose, maxX, minX, startTime, updateCount, yDiffIntegral, and zAccelIntegral.

Parcour::~Parcour | ( |  | ) | `[inline]`

| Destructor. Definition at line 27 of file Parcour.h.

## Member Function Documentation

void Parcour::start | ( |  | ) |

| start walking on the parcour: set start time, reset fitness stuff Definition at line 14 of file Parcour.cpp. References arcDiffIntegral, blindCount, SystemCall::getCurrentSystemTime(), maxX, minX, startTime, updateCount, yDiffIntegral, and zAccelIntegral.

Here is the call graph for this function:

void Parcour::update | ( | Pose2D | robotPose,
|  | Vector3< double > | accel,
|  | bool | blind
| ) |

| update the state of the parcour with all current data Definition at line 27 of file Parcour.cpp. References arcDiffIntegral, blindCount, SystemCall::getCurrentSystemTime(), getTargetPose(), lastRobotPose, maxX, minX, normalize(), Pose2D::rotation, Pose2D::translation, updateCount, yDiffIntegral, Vector3< V >::z, and zAccelIntegral.

Here is the call graph for this function:

Pose2D Parcour::getMotionRequest | ( |  | ) |

| return a MotionRequest that is useful at the moment to follow the parcour Definition at line 43 of file Parcour.cpp. References getTargetPose(), lastRobotPose, Pose2D::minusDiff(), Pose2D::rotation, Pose2D::translation, and Vector2< double >::y.

Here is the call graph for this function:

double Parcour::getUnifiedSpeed | ( |  | ) |

| return something like speed in mm/s considering a useful portion of the integral errors Definition at line 61 of file Parcour.cpp. References arcDiffIntegral, blindCount, idText, maxX, minX, OUTPUT, startTime, updateCount, yDiffIntegral, and zAccelIntegral.

virtual Pose2D Parcour::getTargetPose | ( | unsigned long | targetTime | ) | `[pure virtual]`

| Implemented in ForwardTurningParcour, and SimpleBackwardParcour. Referenced by getMotionRequest(), and update().

## Member Data Documentation

unsigned long Parcour::updateCount

| Definition at line 41 of file Parcour.h. Referenced by getUnifiedSpeed(), Parcour(), start(), and update().

unsigned long Parcour::startTime

| Definition at line 46 of file Parcour.h. Referenced by getUnifiedSpeed(), Parcour(), and start().

unsigned long Parcour::lastTime

| Definition at line 47 of file Parcour.h.

Pose2D Parcour::lastRobotPose

| Definition at line 48 of file Parcour.h. Referenced by getMotionRequest(), Parcour(), and update().

double Parcour::minX

| Definition at line 49 of file Parcour.h. Referenced by getUnifiedSpeed(), Parcour(), start(), and update().

double Parcour::maxX

| Definition at line 49 of file Parcour.h. Referenced by getUnifiedSpeed(), Parcour(), start(), and update().

double Parcour::yDiffIntegral

| Definition at line 50 of file Parcour.h. Referenced by getUnifiedSpeed(), Parcour(), start(), and update().

double Parcour::arcDiffIntegral

| Definition at line 51 of file Parcour.h. Referenced by getUnifiedSpeed(), Parcour(), start(), and update().

int Parcour::blindCount

| Definition at line 52 of file Parcour.h. Referenced by getUnifiedSpeed(), Parcour(), start(), and update().

double Parcour::zAccelIntegral

| Definition at line 53 of file Parcour.h. Referenced by getUnifiedSpeed(), Parcour(), start(), and update().

The documentation for this class was generated from the following files:

- Tools/Evolution/Parcour.h
- Tools/Evolution/Parcour.cpp